#ifndef __MERLIN_H__
#define __MERLIN_H__ 1

#include <stdbool.h>
#include <stdint.h>
#include <usb/LUFA/Common/Architectures.h>
#include <avr/eeprom.h>

//Timings
#define MERLIN_PERIODES_PER_SECOND    4547

#define MERLIN_DEFAULT_PERIOD         (F_CPU/MERLIN_PERIODES_PER_SECOND)
#define MERLIN_MAX_LEVEL              (MERLIN_DEFAULT_PERIOD * 2.5f)
#define MERLIN_MAX_SHORT_LEVEL        (MERLIN_DEFAULT_PERIOD * 1.5f)
#define MERLIN_SKIP_WIDTH             (MERLIN_DEFAULT_PERIOD * 13.5f)




typedef struct merlin_macro_keycodes_t
{
	uint8_t toogle_mouse;
} merlin_macro_keycodes_t;

extern const uint8_t merlin_keycodes[128];

//Returns size or -1 if error
int decode(uint8_t *result);


#endif