#include <config/settings.h>

#if X_MOUSE > 0
#include "mouse.h"

#include <core/scancodes.h>
#include <core/x_scancodes.h>

x_mouse_table_s x_mouse_table EEMEM =
{
	.mouse_left  = X_SC_LEFT_ARROW,
	.mouse_right = X_SC_RIGHT_ARROW,
	.mouse_up    = X_SC_UP_ARROW,
	.mouse_down  = X_SC_DOWN_ARROW,
	.wheel_up    = X_SC_MEDIA_MUTE,
	.wheel_down  = X_SC_SPECIAL1,
	.b1          = X_SC_SPECIAL6,
	.b2          = X_SC_PAGE_UP,
	.b3          = X_SC_PAGE_DOWN,
};

x_mouse_table_s x_mouse_table_backup EEMEM =
{
	.mouse_left  = 0,
	.mouse_right = 0,
	.mouse_up    = 0,
	.mouse_down  = 0,
	.b1          = 0,
	.b2          = 0,
	.b3          = 0,
};

x_mouse_info_t x_mouse_info =
{
	.mouse_mode = false,
	.mouse_jump = 1, //Width to let the mouse jump for every repeat
	.mouse_move_x = 0,
	.mouse_move_y = 0,
	.mouse_wheel = 0,
	.buttons_pressed = 0,
};

bool eval_mouse(uint8_t x_code)
{
	
	//Mouse movement
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_left))
	{
		x_mouse_info.mouse_move_x = -x_mouse_info.mouse_jump;
		return true;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_right))
	{
		x_mouse_info.mouse_move_x = +x_mouse_info.mouse_jump;
		return true;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_down))
	{
		x_mouse_info.mouse_move_y = +x_mouse_info.mouse_jump;
		return true;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.mouse_up))
	{
		x_mouse_info.mouse_move_y = -x_mouse_info.mouse_jump;
		return true;
	}
	//Mouse Wheel
	if(x_code == eeprom_read_byte(&x_mouse_table.wheel_up))
	{
		x_mouse_info.mouse_wheel++;
		return true;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.wheel_down))
	{
		x_mouse_info.mouse_wheel--;
		return true;
	}
	
	//Mouse buttons
	if(x_code == eeprom_read_byte(&x_mouse_table.b1))
	{
		x_mouse_info.buttons_pressed |= (1 << 0);
		return false;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.b2))
	{
		x_mouse_info.buttons_pressed |= (1 << 1);
		return false;
	}
	if(x_code == eeprom_read_byte(&x_mouse_table.b3))
	{
		x_mouse_info.buttons_pressed |= (1 << 2);
		return false;
	}
	return false;
}

#endif