#ifndef _X_MOUSE_H__
#define _X_MOUSE_H__ 1

#include <config/settings.h>

#if X_MOUSE > 0

#include <stdbool.h>
#include <stdint.h>
#include <avr/eeprom.h>

#define X_MOUSE_RESET()                x_mouse_info.mouse_jump = 1; x_mouse_info.buttons_pressed = 0; x_mouse_info.mouse_move_x = 0; x_mouse_info.mouse_move_y = 0

#define X_MOUSE_BACKUP()               x_core_backup_macro((void *)&x_mouse_table, (void *)&x_mouse_table_backup, sizeof(x_mouse_table_s))

#define X_MOUSE_TGL()                  x_core_toggle_macro((uint8_t *)&x_mouse_table, (uint8_t *)&x_mouse_table_backup, sizeof(x_mouse_table_s), HID_SPECIAL_MOUSE, &x_macro_status.mouse_active)

#define X_MOUSE_ACTIV_STRUCT()         bool mouse_active
#define X_MOUSE_ACTIV_INIT             .mouse_active = 0,

#define X_MOUSE_TGL_KEY_STRUCT()       uint8_t mouse
#define X_MOUSE_TGL_KEY_INIT           .mouse = X_MOUSE_TGL_KEY,

typedef struct x_mouse_info_t
{
	volatile bool mouse_mode;
	volatile uint8_t mouse_jump; //Width to let the mouse jump for every repeat
	volatile int8_t mouse_move_x;
	volatile int8_t mouse_move_y;
	volatile int8_t mouse_wheel;
	volatile uint8_t buttons_pressed;
} x_mouse_info_t;

typedef struct x_mouse_table_s
{
	uint8_t mouse_left;
	uint8_t mouse_right;
	uint8_t mouse_up;
	uint8_t mouse_down;
	uint8_t wheel_up;
	uint8_t wheel_down;
	uint8_t b1;
	uint8_t b2;
	uint8_t b3;
} x_mouse_table_s;

extern x_mouse_table_s x_mouse_table EEMEM;
extern x_mouse_table_s x_mouse_table_backup EEMEM;

extern x_mouse_info_t x_mouse_info;

bool eval_mouse(uint8_t x_code);


#else

#define X_MOUSE_RESET()

#define X_MOUSE_BACKUP()

#define X_MOUSE_TGL()


#define X_MOUSE_ACTIV_STRUCT()
#define X_MOUSE_ACTIV_INIT

#define X_MOUSE_TGL_KEY_STRUCT()
#define X_MOUSE_TGL_KEY_INIT

#endif

#endif