#ifndef __MEGA_USB_H__
#define __MEGA_USB_H__ 1

#include <stdint.h>

#include <config/v-usbconfig.h>
#include <usb/v-usb/usbdrv.h>

typedef struct {
	uint8_t report_id;
	uint8_t modifier;
// 	uint8_t reserved;
	uint8_t keycode[6];
} keyboard_report_t;

typedef struct {
	uint8_t report_id;
	uint8_t buttons;
	uint8_t axis_x;
	uint8_t axis_y;
	uint8_t wheel;
} mouse_report_t;

extern keyboard_report_t keyboard_report;

extern mouse_report_t mouse_report;

extern const char usbHidReportDescriptor[USB_CFG_HID_REPORT_DESCRIPTOR_LENGTH];


usbMsgLen_t usbFunctionWrite(uint8_t * data, uchar len);
usbMsgLen_t usbFunctionSetup(uchar data[8]);


#endif