#ifndef __QEEP_ADDR_H__
#define __QEEP_ADDR_H__ 1

#include <stdint.h>
#include <avr/eeprom.h>

typedef struct Qeep_bytes_s
{
  //<-- if you want to add things do it here
  uint8_t Qclock;       //if this has the Value 'Q'
  uint8_t Qcal_done;    //and this has the value 'C'
  uint8_t clock_cal;    //the best clock calibration value can be found here
} Qeep_bytes;


#define QEEP_ADDR ((void * ) (EEPROM_START + EEPROM_SIZE - 1 - 4 - sizeof(Qeep_bytes)))
//minus 4 because of count write cycles

#define QEEP_ADDR_READ(DST) (eeprom_read_block(DST, QEEP_ADDR, sizeof(Qeep_bytes)))
#define QEEP_ADDR_WRITE(SRC) (eeprom_write_block(SRC, QEEP_ADDR, sizeof(Qeep_bytes)))










#endif